﻿/* Copyright 2008-10 Jarrett Vance
 * see http://www.codeplex.com/blogsvc/license */
namespace AtomSite.WebCore.Modules
{
  using System;
  using System.Web;

  public class FormsBypassModule : IHttpModule
  {
    public virtual void Init(HttpApplication context)
    {
      context.EndRequest += OnEndRequest;
    }

    public virtual void Dispose() { }

    void OnEndRequest(object sender, EventArgs e)
    {
      OnEndRequest(((HttpApplication)sender).Context);
    }

    protected virtual void OnEndRequest(HttpContext context)
    {
      if (context.Response.StatusCode == 302 &&
                context.Items.Contains("FormsAuthBypass") && (bool)context.Items["FormsAuthBypass"])
      {
        context.Response.Clear();
        //context.Response.Headers.Remove("Location"); //only works with IIS7
        context.Response.ContentType = null;
        context.Response.StatusCode = 401;
        context.Response.StatusDescription = "Access Denied";
      }
    }
  }
}