﻿/* Copyright 2008-10 Jarrett Vance
 * see http://www.codeplex.com/blogsvc/license */
namespace AtomSite.WebCore
{
  using System.Web.Mvc;
  using System.Web.Routing;
  using StructureMap;
  using StructureMap.Attributes;
  using AtomSite.Domain;
  using System.Collections.Generic;

  public class AtomPubPlugin : BasePlugin
  {
    public AtomPubPlugin(ILogService logger)
      : base(logger)
    {
      DefaultMerit = (int)MeritLevel.High;
    }

    public override void Register(IContainer container, List<SiteRoute> routes, ViewEngineCollection viewEngines, ModelBinderDictionary modelBinders, ICollection<Asset> globalAssets)
    {
      container.Configure(x =>
      {
        x.ForRequestedType<IAtomPubService>().CacheBy(InstanceScope.Singleton)
          .TheDefault.Is.OfConcreteType<AtomPubService>();
        
        //this is default controller for all, no name given
        x.ForRequestedType<IController>().TheDefault.Is.OfConcreteType<AtomPubController>();
      });

      RegisterController<AtomPubController>(container);
      RegisterRoutes<AtomPubRouteRegistrar>(container, routes);
    }
  }
}
